header {* Very Simple Predicate Logic *}
theory VSFOL
imports "../VSPL/VSPL"
begin

typedecl i   --{* Terms *}

section {* Der Allquantor *}

axiomatization
  All  :: "('a => o)=> o"      (binder "\<forall>" 10)
where
  allI:   "(!!x. P x) ==> (\<forall> x. P x)"
and
  allE:   "\<forall> x. P x ==> P t"


section{* Der Existenzquantor *}

definition
  Ex :: "('a => o)=> o"      (binder "\<exists>" 10)
where
  "Ex P == \<not> (\<forall> x. (\<not> (P x)))" 

lemma exI: "P t ==> \<exists> x. P x"
 apply (unfold Ex_def)
 apply (rule notI)
 apply (rule notE [where P="P t"])
 apply (rule allE [where t="t"])
 apply (assumption)
 apply (assumption)
 done

lemma exE: "[| \<exists> x. P x; !! x. P x ==> Q |] ==> Q"
 apply (unfold Ex_def)
 apply (rule Raa')
 apply (erule notE [where P="\<forall> x. \<not> P x"]) 
 apply (rule allI)
 apply (rule notI)
 apply (rule notE [where P="Q"])
 apply (assumption)
 apply (assumption)
 done

end
