header {* Einige Beispiele in einfacher Aussagenlogik. *}
theory VSPLSimpleEx
imports "../VSPL0"
begin

text{* 
  Das erste Lemma: Konjunktivität der Konjunktion. 
  *}
lemma conj_comm: "X \<and> Y \<longrightarrow> Y \<and> X"
  apply (rule impI)
  apply (rule conjI)
  apply (rule conjE2 [where P="X"]) 
       --{* Angabe der Instantiierung, um Variable ?P5 im Beweisziel 
            zu vermeiden. *}
  apply (assumption) --{* Beweis durch Benutzung der Annahme *}
  apply (erule conjE1)
      --{* erule conjE1 fasst die beiden Schritte apply(rule ...), assumption
           zusammen. *}
done

lemma tafelbeweis: "(X \<longrightarrow> (Y \<longrightarrow> Z))\<longrightarrow> (X \<and> Y \<longrightarrow> Z)"
  apply (rule impI)
  apply (rule impI)
  apply (rule impE [where P="Y"]) --{* Konkrete Instantiierung für P *} 
  apply (rule impE [where P="X"]) 
  apply (assumption) 
  apply (rule conjE1)
  apply (assumption)
  apply (rule conjE2, assumption)
  done

end

