header {* Very Simple Propositional Logic I *}
theory VSPL0
imports Pure
begin

text{* 
  Hier wird der Typ o deklariert; für die einfache Aussagenlogik 
  gibt es nur einen einzigen Typ. *} 
typedecl o

text{* Dieser Teil ist rein technischer Natur. *}
judgment
  Trueprop  :: "o => prop"                  ("(_)" 5)

text{* 
  Deklaration der Konstanten False, And, Implies.
  (Der Teil in Klammern sorgt für schicke Syntax, e.g. A \<and> B).
  *}

axiomatization
      False   :: o                            ("\<bottom>")
  and And     :: "[o, o] => o"                (infixr "\<and>" 35)
  and Implies :: "[o, o] => o"                (infixr "\<longrightarrow>" 25)

text{* 
  Die sieben Grundregeln der einfachen Aussagenlogik.
  *}

axiomatization where
      conjI:  "[| P;  Q |] ==> P \<and> Q"
  and conjE1: "P \<and> Q ==> P"
  and conjE2: "P \<and> Q ==> Q"

  and impI:   "(P ==> Q) ==> P \<longrightarrow> Q"
  and impE:   "[| P \<longrightarrow> Q ; P|] ==> Q"

  and False:  "[| \<bottom> |] ==> P"
  and Raa:    "[| P\<longrightarrow> \<bottom> ==> \<bottom> |] ==> P"


lemma conj_comm: "A \<and> B \<longrightarrow> B \<and> A"  
  apply (rule impI)
  apply (rule conjI)
  apply (rule conjE2 [where P= "A"])
  apply (assumption)
  apply (rule conjE1 [where Q= "B"])
  apply (assumption)
  done

text{*
  Zwei einfache Eigenschaften, die wir später benötigen.
  *}

lemma doubleneg: "((A \<longrightarrow> \<bottom>)\<longrightarrow> \<bottom>)\<longrightarrow> A"
  apply (rule impI)
  apply (rule Raa)
  apply (rule impE [where P="A\<longrightarrow> \<bottom>"])
  apply (assumption)
  apply (assumption)
  done

lemma doubleneg2: "A\<longrightarrow> ((A\<longrightarrow> \<bottom>)\<longrightarrow> \<bottom>)"
  apply (rule impI)
  apply (rule impI)
  apply (rule impE [where P="A"])
  apply (assumption)+ 
  done

end

